diff --git a/.tarball-version b/.tarball-version
new file mode 100644
index 0000000..fc73074
--- /dev/null
+++ b/.tarball-version
@@ -0,0 +1 @@
+0.94
diff --git a/FORMATS b/FORMATS
index 3e64e17..d0e05ff 100644
--- a/FORMATS
+++ b/FORMATS
@@ -11,7 +11,7 @@ The split format is:
 
 The "raw" format is:
 
-hostline|xmitline|pingline|dnsline|timestampline
+hostline|xmitline|pingline|dnsline|timestampline|mplsline
 
 hostline:
 h <pos> <host IP>
@@ -28,6 +28,8 @@ d <pos> <hostname>
 timestampline:
 t <pos> <pingtime> <timestamp>
 
+mplsline:
+m <pos> <label> <traffic_class> <bottom_stack> <ttl>
 
 Timestampline is not  yet implemented. Need to find out how to do
 ICMP timestamping first. :-)
diff --git a/Makefile.am b/Makefile.am
index 29435e1..7719be1 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -55,6 +55,7 @@ mtr_SOURCES = ui/mtr.c ui/mtr.h \
               ui/select.c ui/select.h \
               ui/utils.c ui/utils.h \
               packet/cmdparse.c packet/cmdparse.h \
+              packet/sockaddr.c packet/sockaddr.h \
               ui/mtr-curses.h \
               img/mtr_icon.xpm \
               ui/mtr-gtk.h
@@ -84,9 +85,15 @@ if WITH_GTK
 mtr_SOURCES += ui/gtk.c
 endif
 
+if WITH_LIBASAN
+ASAN_CFLAGS = -fno-omit-frame-pointer
+ASAN_CFLAGS += -fsanitize=undefined
+ASAN_CFLAGS += -fsanitize=address
+endif
+
 mtr_INCLUDES = $(GLIB_CFLAGS) -I$(top_builddir) -I$(top_srcdir)
-mtr_CFLAGS = $(GTK_CFLAGS) $(NCURSES_CFLAGS)
-mtr_LDADD = $(GTK_LIBS) $(NCURSES_LIBS) $(RESOLV_LIBS)
+mtr_CFLAGS = $(GTK_CFLAGS) $(NCURSES_CFLAGS) $(ASAN_CFLAGS) $(JANSSON_CFLAGS)
+mtr_LDADD = $(GTK_LIBS) $(NCURSES_LIBS) $(RESOLV_LIBS) $(JANSSON_LIBS)
 
 
 mtr_packet_SOURCES = \
diff --git a/NEWS b/NEWS
index bb2bf87..922036e 100644
--- a/NEWS
+++ b/NEWS
@@ -4,6 +4,76 @@ The new release script will do a "git shortlog" to add
 the commit messages here. 
 
 #NEW_STUFF_HERE this is a tag my script looks for. 
+V0.94
+   Aaron Lipinski (10):
+         gtk_menu_append -> gtk_menu_shell_append
+         GTK_OBJECT -> G_OBJECT
+         gtk_button_new_from_stock -> gtk_button_new_with_label
+         gtk3
+         hbox/vbox -> gtk_box_new
+         gtk_menu_popup -> gtk_menu_popup_at_pointer
+         show resolved hostname in raw dnsline
+         rely on final return NULL
+         introduce libasan
+         avoid stack use after scope
+   
+   Alejandro Leal (2):
+         few updates to manual page and README.md
+         Updating some comments
+   
+   Chongyu Zhu (1):
+         probe: fix find_source_addr
+   
+   Konrad Bucheli (1):
+         fix segmentation fault if there is no IP address on an interface (fixes #320)
+   
+   Kulemin Alexander (1):
+         report: json: reworked with libjansson
+   
+   Mark Egan-Fuller (1):
+         Add display of destination.
+   
+   Markus Kötter (6):
+         simplification - remove sockaddrtop
+         simplification - remove addrcpy
+         simplification - remove rsa{4,6}
+         simplification - address addrcmp
+         simplification - improve readability
+         ip6 udp - fix probes with local or remote port
+   
+   R.E. Wolff (29):
+         fix warning on recent compilers.
+         Merge branch 'master' of github.com:traviscross/mtr
+         net find local address fix by meingtsla
+         proposed patch for bsd compile error
+         fix closing brace
+         Added include errno --obouizi
+         Merge branch 'master' of github.com:traviscross/mtr
+         More compilation warning fixes from obouizi
+         Added extra help text to configure --yvs
+         Changed MAXPATH to MAX_PATH for AIX compatibility. -- aixtools
+         make the code for gtk2/3 a bit nicer.
+         Merge branch 'gtk3_with_fallback' of https://github.com/krisl/mtr
+         Merge branch 'master' of github.com:traviscross/mtr
+         in hindsight my previous patch wasn't so nice. And nobody told me.
+   
+   Sean Wei (1):
+         Fix parameter in ui/net.c
+   
+   Siyuan Miao (1):
+         show mpls information in raw output
+   
+   atib (1):
+         Added code to print multiple addresses regitered on the same hop count
+   
+   atibdialpad (2):
+         Change TTL dynamically to adjust for path changes
+         TODO list changes
+   
+   meingtsla (2):
+         asn_{open,close}: Always initialize ipinfo hash table
+         Merge branch 'master' of https://github.com/traviscross/mtr into asn-open-always-hcreate
+   
 V0.93
     Adam (1):
           Update README
diff --git a/README.md b/README.md
index 77b6f79..9db7b62 100644
--- a/README.md
+++ b/README.md
@@ -31,7 +31,7 @@ If you're building from the git repository, you'll need to run:
 
 	./bootstrap.sh && ./configure && make
 
-When it looks as if the compilation was succesful, you can
+When it looks as if the compilation was successful, you can
 test mtr with
 
 	sudo ./mtr <host>
diff --git a/TODO b/TODO
index 0673b24..ed8950f 100644
--- a/TODO
+++ b/TODO
@@ -41,14 +41,12 @@ Oh, Feel free to provide suggestions for this list.
   - Keep all packets and make the "best" and "worst" columns show the
     xx-th percentile....
 
-  - Can the reports generated also include any secondary servers?  In 
-    the interactive mode, any new servers that are found in the 
-    traceroute are added to the list, but it seems to only include 
-    one set of servers when using the -r option.  
-
   - Being able to expand the "column width" of the hosts listed would 
     be nice, too.
 
+  - Display per host stats when multiple servers respond at a particular
+    hop count.
+
 
 - Bugs to fix?
 
diff --git a/configure.ac b/configure.ac
index ad81332..3175d56 100644
--- a/configure.ac
+++ b/configure.ac
@@ -21,12 +21,11 @@ AC_CANONICAL_HOST
 AC_PROG_CC
 
 # Check pkg-config availability.
-m4_ifndef([PKG_PROG_PKG_CONFIG],
-  [m4_fatal(
+m4_ifndef([PKG_CHECK_MODULES], [m4_defun([PKG_CHECK_MODULES], [AC_MSG_ERROR(
 [Could not locate the pkg-config autoconf macros.  These are usually located
 in /usr/share/aclocal/pkg.m4.  If your macros are in a different location,
 try setting the environment variable ACLOCAL_OPTS="-I/other/macro/dir"
-before running ./bootstrap.sh again.])
+before running ./bootstrap.sh again, or configure --without-gtk ----without-jansson ])])
 ])
 PKG_PROG_PKG_CONFIG
 
@@ -84,17 +83,35 @@ AM_CONDITIONAL([WITH_GETOPT], [test "x$with_getopt" = "xyes"])
 
 AC_CHECK_LIB([m], [floor], [], [AC_MSG_ERROR([No math library found])])
 
+# libasan
+AC_ARG_WITH([libasan],
+ [AS_HELP_STRING([--with-libasan], [Build with AddressSanitizer])],
+ [with_libasan=yes], [])
+AM_CONDITIONAL([WITH_LIBASAN], [test "x$with_libasan" = "xyes"])
+
 # Find GTK
 AC_ARG_WITH([gtk],
-  [AS_HELP_STRING([--without-gtk], [Build without the GTK+2.0 interface])],
+  [AS_HELP_STRING([--without-gtk], [Build without the GTK+ interface])],
   [], [with_gtk=yes])
 AS_IF([test "x$with_gtk" = "xyes"],
-  [PKG_CHECK_MODULES([GTK], [gtk+-2.0],
-    [AC_DEFINE([HAVE_GTK], [1], [Define if gtk+-2.0 library available])],
-    [with_gtk=no])
+  [PKG_CHECK_MODULES([GTK], [gtk+-3.0],
+    [AC_DEFINE([HAVE_GTK], [1], [Define if gtk+ library available])]
+      [AC_DEFINE([HAVE_GTK3], [1], [Define if gtk+-3.0 library available])],
+    [PKG_CHECK_MODULES([GTK], [gtk+-2.0],
+      [AC_DEFINE([HAVE_GTK], [1], [Define if gtk+ library available])],
+      [with_gtk=no])])
 ])
 AM_CONDITIONAL([WITH_GTK], [test "x$with_gtk" = xyes])
 
+AC_ARG_WITH([jansson],
+  [AS_HELP_STRING([--without-jansson], [Build without JSON output])],
+  [], [with_jansson=yes])
+AS_IF([test "x$with_jansson" = "xyes"],
+  [PKG_CHECK_MODULES([JANSSON], [jansson],
+    [AC_DEFINE([HAVE_JANSSON], [1], [Define if jansson library available])],
+    [with_jansson=no])
+])
+
 # Find ncurses
 AC_ARG_WITH([ncurses],
   [AS_HELP_STRING([--without-ncurses], [Build without the ncurses interface])],
@@ -245,10 +262,12 @@ AC_ARG_ENABLE([bash-completion],
 AM_CONDITIONAL([BUILD_BASH_COMPLETION], [test "x$enable_bash_completion" = xyes])
 echo "build options:"
 echo "--------------"
+echo "libasan :$with_libasan"
 echo "ipv6    :$USES_IPV6"
 echo "ipinfo  :$with_ipinfo"
 echo "ncurses :$with_ncurses"
 echo "gtk     :$with_gtk"
+echo "jansson :$with_jansson"
 echo "cap     :$have_cap"
 echo "libs    :$LIBS"
 echo "cflags  :$CFLAGS"
diff --git a/man/mtr-packet.8.in b/man/mtr-packet.8.in
index 9c02470..090c3ad 100644
--- a/man/mtr-packet.8.in
+++ b/man/mtr-packet.8.in
@@ -121,7 +121,7 @@ probes.
 .I IP-ADDRESS
 .HP 14
 .IP
-The local Internet Procol version 4 address to use when sending probes.
+The local Internet Protocol version 4 address to use when sending probes.
 .HP 7
 .IP
 .B local-ip-6
@@ -407,7 +407,7 @@ value, are used.
 \&...
 .RE 0
 .LP
-Each interemediate host would respond with a
+Each intermediate host would respond with a
 .B ttl-expired
 message, and the destination host would respond with a
 .BR reply :
diff --git a/man/mtr.8.in b/man/mtr.8.in
index db55012..9d13535 100644
--- a/man/mtr.8.in
+++ b/man/mtr.8.in
@@ -138,7 +138,7 @@ A sudden increase in packet loss or response time is often an indication
 of a bad (or simply overloaded) link. 
 .PP
 The results are usually reported as round-trip-response times in milliseconds
-and the percentage of packetloss. 
+and the percentage of packet loss. 
 .SH OPTIONS
 .TP
 .B \-h\fR, \fB\-\-help
@@ -267,6 +267,9 @@ Use this option to tell
 .B mtr
 to use the JSON output format.  This format is better suited for
 automated processing of the measurement results.
+Jansson library must have been available on the system when
+.B mtr
+was built for this to work.
 .TP
 .B \-p\fR, \fB\-\-split
 Use this option to set
diff --git a/packet/cmdparse.c b/packet/cmdparse.c
index 76e6c91..85757b6 100644
--- a/packet/cmdparse.c
+++ b/packet/cmdparse.c
@@ -66,8 +66,8 @@ int tokenize_command(
     structure for later semantic interpretation.  Returns EINVAL if the
     command string is unparseable or zero for success.
 
-    comamnd_string will be modified in-place with NUL characters terminating
-    tokens, and the command_t will use pointers to the conents of
+    command_string will be modified in-place with NUL characters terminating
+    tokens, and the command_t will use pointers to the contents of
     command_string without copying, so any interpretation of the
     command_t structure requires that the command_string memory has not yet
     been freed or otherwise reused.
diff --git a/packet/construct_unix.c b/packet/construct_unix.c
index 09250bc..dff17d8 100644
--- a/packet/construct_unix.c
+++ b/packet/construct_unix.c
@@ -724,7 +724,7 @@ int construct_ip6_packet(
     /*
        Check the current socket address, and if it is the same
        as the source address we intend, we will skip the bind.
-       This is to accomodate Solaris, which, as of Solaris 11.3,
+       This is to accommodate Solaris, which, as of Solaris 11.3,
        will return an EINVAL error on bind if the socket is already
        bound, even if the same address is used.
      */
@@ -754,7 +754,7 @@ int construct_ip6_packet(
         }
     }
 
-    /*  The traffic class in IPv6 is analagous to ToS in IPv4  */
+    /*  The traffic class in IPv6 is analogous to ToS in IPv4  */
     if (setsockopt(send_socket, IPPROTO_IPV6,
                    IPV6_TCLASS, &param->type_of_service, sizeof(int))) {
         return -1;
diff --git a/packet/probe.c b/packet/probe.c
index 0177e97..48f11b6 100644
--- a/packet/probe.c
+++ b/packet/probe.c
@@ -38,6 +38,8 @@
 #include "timeval.h"
 #include "sockaddr.h"
 
+char *probe_err;
+
 /*  Convert the destination address from text to sockaddr  */
 int decode_address_string(
     int ip_version,
@@ -98,18 +100,23 @@ int resolve_probe_addresses(
 {
     if (decode_address_string
         (param->ip_version, param->remote_address, dest_sockaddr)) {
+        probe_err = "decode address string remote";
         return -1;
     }
 
     if (param->local_address) {
         if (decode_address_string
             (param->ip_version, param->local_address, src_sockaddr)) {
+            probe_err = "decode address string local";
             return -1;
         }
     } else {
+        probe_err = "find source address";
         if (find_source_addr(src_sockaddr, dest_sockaddr)) {
+            //probe_err = "find source address";
             return -1;
         }
+        probe_err = "";
     }
     /* DGRAM ICMP id is taken from src_port not from ICMP header */
     if (param->protocol == IPPROTO_ICMP) {
@@ -311,8 +318,12 @@ int find_source_addr(
     int sock;
     int len;
     struct sockaddr_storage dest_with_port;
+#ifdef __linux__
+    // The Linux code needs these. 
     struct sockaddr_in *srcaddr4;
     struct sockaddr_in6 *srcaddr6;
+#endif
+
 
     dest_with_port = *destaddr;
 
@@ -323,16 +334,18 @@ int find_source_addr(
        anything to the port.
      */
     *sockaddr_port_offset(&dest_with_port) = htons(1);
-    len = sockaddr_addr_size(&dest_with_port);
+    len = sockaddr_size(&dest_with_port);
 
     sock = socket(destaddr->ss_family, SOCK_DGRAM, IPPROTO_UDP);
     if (sock == -1) {
+        probe_err = "open socket";
         return -1;
     }
 
     if (connect(sock, (struct sockaddr *) &dest_with_port, len) == 0) {
         if (getsockname(sock, (struct sockaddr *) srcaddr, &len)) {
             close(sock);
+            probe_err = "getsockname";
             return -1;
         }
     } else {
@@ -341,6 +354,7 @@ int find_source_addr(
          * a case when mtr is run against unreachable host (that can become
          * reachable) */
         if (errno != EHOSTUNREACH) {
+            probe_err = "not hostunreach";
             close(sock);
             return -1;
         }
@@ -354,6 +368,7 @@ int find_source_addr(
         }
 #else
         close(sock);
+        probe_err = "connect failed";
         return -1;
 #endif
     }
@@ -364,7 +379,7 @@ int find_source_addr(
        Zero the port, as we may later use this address to finding, and
        we don't want to use the port from the socket we just created.
      */
-    *sockaddr_port_offset(&srcaddr) = 0;
+    *sockaddr_port_offset(srcaddr) = 0;
 
     return 0;
 }
diff --git a/packet/probe.h b/packet/probe.h
index 53b8037..e7b8bee 100644
--- a/packet/probe.h
+++ b/packet/probe.h
@@ -68,7 +68,7 @@ struct probe_param_t {
     /*  The packet "mark" used for mark-based routing on Linux  */
     int routing_mark;
 
-    /*  Time to live for the transmited probe  */
+    /*  Time to live for the transmitted probe  */
     int ttl;
 
     /*  The packet size (in bytes) including protocol headers  */
@@ -207,4 +207,6 @@ int find_source_addr(
     struct sockaddr_storage *srcaddr,
     const struct sockaddr_storage *destaddr);
 
+extern char *probe_err;
+
 #endif
diff --git a/packet/probe_cygwin.c b/packet/probe_cygwin.c
index 79e9fdb..ab477be 100644
--- a/packet/probe_cygwin.c
+++ b/packet/probe_cygwin.c
@@ -81,7 +81,7 @@
 
     We use the Cygwin pipe() to create the pipes, but in the ICMP
     service thread we use the Win32 HANDLE that corresponds to the
-    recieving end of the input pipe to wait for ICMP requests.
+    receiving end of the input pipe to wait for ICMP requests.
 */
 
 
@@ -94,7 +94,7 @@ void init_net_state_privileged(
 }
 
 /*
-    Convienience similar to error(), but for reporting Windows
+    Convenience similar to error(), but for reporting Windows
     error codes instead of errno codes.
 */
 void error_win(int exit_code, int win_error, const char *str) {
@@ -483,7 +483,7 @@ DWORD WINAPI icmp_service_thread(LPVOID param) {
     HANDLE event;
     BOOL success;
     bool read_pending;
-    int read_count;
+    DWORD read_count;
     int err;
 
     /*
@@ -717,7 +717,7 @@ void receive_replies(
 }
 
 /*
-    On Windows, an implementation of check_probe_timeout is unnecesary because
+    On Windows, an implementation of check_probe_timeout is unnecessary because
     timeouts are managed by ICMP.DLL, including a call to the I/O completion
     routine when the time fully expires.
 */
diff --git a/packet/probe_unix.c b/packet/probe_unix.c
index 363930f..e77e46f 100644
--- a/packet/probe_unix.c
+++ b/packet/probe_unix.c
@@ -52,9 +52,12 @@ int send_packet(
     int packet_size,
     const struct sockaddr_storage *sockaddr)
 {
+    struct sockaddr_storage dst;
     int send_socket = 0;
     int sockaddr_length;
 
+    memcpy(&dst, sockaddr, sizeof(struct sockaddr_storage));
+
     if (sockaddr->ss_family == AF_INET6) {
         sockaddr_length = sizeof(struct sockaddr_in6);
 
@@ -67,12 +70,17 @@ int send_packet(
         } else if (param->protocol == IPPROTO_UDP) {
             if (net_state->platform.ip6_socket_raw) {
                 send_socket = net_state->platform.udp6_send_socket;
+                /* we got a ipv6 udp raw socket
+                 * the remote port is in the payload
+                 * we do not set in the sockaddr
+                 */
+                *sockaddr_port_offset(&dst) = 0;
             } else {
                 send_socket = net_state->platform.ip6_txrx_udp_socket;
                 if (param->dest_port) {
-                    *sockaddr_port_offset(sockaddr) = htons(param->dest_port);
+                    *sockaddr_port_offset(&dst) = htons(param->dest_port);
                 } else {
-                    *sockaddr_port_offset(sockaddr) = sequence;
+                    *sockaddr_port_offset(&dst) = sequence;
                 }
             }
         }
@@ -91,9 +99,9 @@ int send_packet(
             } else if (param->protocol == IPPROTO_UDP) {
                 send_socket = net_state->platform.ip4_txrx_udp_socket;
                 if (param->dest_port) {
-                    *sockaddr_port_offset(sockaddr) = htons(param->dest_port);
+                    *sockaddr_port_offset(&dst) = htons(param->dest_port);
                 } else {
-                    *sockaddr_port_offset(sockaddr) = sequence;
+                    *sockaddr_port_offset(&dst) = sequence;
                 }
             }
         }
@@ -105,7 +113,7 @@ int send_packet(
     }
 
     return sendto(send_socket, packet, packet_size, 0,
-                  (struct sockaddr *) sockaddr, sockaddr_length);
+                  (struct sockaddr *) &dst, sockaddr_length);
 }
 
 /*
@@ -145,7 +153,8 @@ void check_length_order(
 
     if (resolve_probe_addresses(net_state, &param, &p0.remote_addr,
                 &p0.local_addr)) {
-        fprintf(stderr, "Error decoding localhost address\n");
+        fprintf(stderr, "Error decoding localhost address (%s/%s)\n", 
+                probe_err, strerror (errno));
         exit(EXIT_FAILURE);
     }
 
@@ -683,7 +692,7 @@ void receive_probe(
 
 /*
     Read all available packets through our receiving raw socket, and
-    handle any responses to probes we have preivously sent.
+    handle any responses to probes we have previously sent.
 */
 static
 void receive_replies_from_recv_socket(
@@ -795,7 +804,6 @@ void receive_replies_from_recv_socket(
                 memcpy(&remote_addr, SO_EE_OFFENDER(ee), sizeof(remote_addr));
             }
         }
-#endif
 
 #ifdef SO_PROTOCOL
         if (icmp_connrefused_received) {
@@ -814,12 +822,15 @@ void receive_replies_from_recv_socket(
             handle_error_queue_packet(net_state, &remote_addr, ICMP_TIME_EXCEEDED, proto,
                     packet, packet_length, &timestamp);
         } else {
+#endif
 #endif
             /* ICMP packets received from raw socket */
             handle_received_packet(net_state, &remote_addr, packet,
                                    packet_length, &timestamp);
+#ifdef HAVE_LINUX_ERRQUEUE_H
 #ifdef SO_PROTOCOL
         }
+#endif
 #endif
     }
 }
diff --git a/packet/probe_unix.h b/packet/probe_unix.h
index cc01e1e..0ce7657 100644
--- a/packet/probe_unix.h
+++ b/packet/probe_unix.h
@@ -40,7 +40,7 @@ struct probe_platform_t {
     struct timeval departure_time;
 };
 
-/*  We'll use rack sockets to send and recieve probes on Unix systems  */
+/*  We'll use rack sockets to send and receive probes on Unix systems  */
 struct net_state_platform_t {
     /*  true if we were successful at opening IPv4 sockets  */
     bool ip4_present;
diff --git a/packet/wait_cygwin.c b/packet/wait_cygwin.c
index 6f93fb1..0546231 100644
--- a/packet/wait_cygwin.c
+++ b/packet/wait_cygwin.c
@@ -19,6 +19,7 @@
 #include "wait.h"
 
 #include <error.h>
+#include <errno.h>
 #include <sys/select.h>
 
 #include "command.h"
diff --git a/packet/wait_unix.c b/packet/wait_unix.c
index 06d2ea7..ad14238 100644
--- a/packet/wait_unix.c
+++ b/packet/wait_unix.c
@@ -104,7 +104,7 @@ int gather_read_fds(
     Sleep until we receive a new probe response, a new command on the
     command stream, or a probe timeout.  On Unix systems, this means
     we use select to wait on file descriptors for the command stream
-    and the raw recieve socket.
+    and the raw receive socket.
 */
 void wait_for_activity(
     struct command_buffer_t *command_buffer,
diff --git a/test/packet_listen.c b/test/packet_listen.c
index a822707..9a1d931 100644
--- a/test/packet_listen.c
+++ b/test/packet_listen.c
@@ -34,7 +34,7 @@
 #define SEQUENCE_NUM 33000
 
 /*
-    Check to see if the packet we've recieved is intended for this test
+    Check to see if the packet we've received is intended for this test
     process.  We expected the ICMP sequence number to be equal to our
     process ID.
 */
diff --git a/test/param.py b/test/param.py
index d220019..edb8f5c 100755
--- a/test/param.py
+++ b/test/param.py
@@ -62,7 +62,7 @@ class TestParameters(mtrpacket.MtrPacketTest):
 
 @unittest.skipIf(sys.platform == 'cygwin', 'No Cygwin test')
 class TestIPv6Parameters(mtrpacket.MtrPacketTest):
-    'Test packet paramter customization for IPv6'
+    'Test packet parameter customization for IPv6'
 
     @unittest.skipUnless(mtrpacket.HAVE_IPV6, 'No IPv6')
     def test_param(self):
diff --git a/test/probe.py b/test/probe.py
index e69214c..b1f0fff 100755
--- a/test/probe.py
+++ b/test/probe.py
@@ -208,7 +208,7 @@ class TestProbeICMPv4(mtrpacket.MtrPacketTest):
     def test_ttl_expired(self):
         'Test sending a probe which will have its time-to-live expire'
 
-        #  Probe Goolge's DNS server, but give the probe only one hop
+        #  Probe Google's DNS server, but give the probe only one hop
         #  to live.
         self.write_command('16 send-probe ip-4 8.8.8.8 ttl 1')
         reply = self.parse_reply()
@@ -220,7 +220,7 @@ class TestProbeICMPv4(mtrpacket.MtrPacketTest):
         '''Test sending multiple probes in parallel
 
         We will expect the probes to complete out-of-order by sending
-        a probe to a distant host immeidately followed by a probe to
+        a probe to a distant host immediately followed by a probe to
         the local host.'''
 
         success_count = 0
@@ -300,7 +300,7 @@ class TestProbeICMPv6(mtrpacket.MtrPacketTest):
     def test_ttl_expired(self):
         'Test sending a probe which will have its time-to-live expire'
 
-        #  Probe Goolge's DNS server, but give the probe only one hop
+        #  Probe Google's DNS server, but give the probe only one hop
         #  to live.
         cmd = '53 send-probe ip-6 ' + self.google_addr + ' ttl 1'
         self.write_command(cmd)
diff --git a/ui/asn.c b/ui/asn.c
index 0ed0398..2310a1b 100644
--- a/ui/asn.c
+++ b/ui/asn.c
@@ -313,17 +313,15 @@ int is_printii(
 void asn_open(
     struct mtr_ctl *ctl)
 {
-    if (ctl->ipinfo_no >= 0) {
-        DEB_syslog(LOG_INFO, "hcreate(%d)", IIHASH_HI);
-        if (!(iihash = hcreate(IIHASH_HI)))
-            error(0, errno, "ipinfo hash");
-    }
+    DEB_syslog(LOG_INFO, "hcreate(%d)", IIHASH_HI);
+    if (!(iihash = hcreate(IIHASH_HI)))
+        error(0, errno, "ipinfo hash");
 }
 
 void asn_close(
     struct mtr_ctl *ctl)
 {
-    if ((ctl->ipinfo_no >= 0) && iihash) {
+    if (iihash) {
         DEB_syslog(LOG_INFO, "hdestroy()");
         hdestroy();
         iihash = 0;
diff --git a/ui/cmdpipe.c b/ui/cmdpipe.c
index 3581086..a919754 100644
--- a/ui/cmdpipe.c
+++ b/ui/cmdpipe.c
@@ -73,9 +73,9 @@ int send_synchronous_command(
     struct mtr_ctl *ctl,
     struct packet_command_pipe_t *cmdpipe,
     const char *cmd,
-    struct command_t *result)
+    struct command_t *result,
+    char *reply)
 {
-    char reply[PACKET_REPLY_BUFFER_SIZE];
     int command_length;
     int write_length;
     int read_length;
@@ -120,11 +120,12 @@ int check_feature(
 {
     char check_command[COMMAND_BUFFER_SIZE];
     struct command_t reply;
+    char reply_buf[PACKET_REPLY_BUFFER_SIZE];
 
     snprintf(check_command, COMMAND_BUFFER_SIZE,
              "1 check-support feature %s\n", feature);
 
-    if (send_synchronous_command(ctl, cmdpipe, check_command, &reply) ==
+    if (send_synchronous_command(ctl, cmdpipe, check_command, &reply, reply_buf) ==
         -1) {
         return -1;
     }
@@ -206,7 +207,7 @@ int check_packet_features(
 
 extern char *myname;
 /*
-    Execute mtr-packet, allowing the MTR_PACKET evironment to override
+    Execute mtr-packet, allowing the MTR_PACKET environment to override
     the PATH when locating the executable.
 */
 static
@@ -754,7 +755,7 @@ void consume_reply_buffer(
         /*
            Terminate the reply string at the newline, which
            is necessary in the case where we are able to read
-           mulitple replies arriving simultaneously.
+           multiple replies arriving simultaneously.
          */
         *end_of_reply = 0;
 
diff --git a/ui/curses.c b/ui/curses.c
index b0bc02e..34bf30d 100644
--- a/ui/curses.c
+++ b/ui/curses.c
@@ -424,8 +424,7 @@ static void mtr_curses_hosts(
         addr = net_addr(at);
         mpls = net_mpls(at);
 
-        addrcmp_result = addrcmp(
-            (void *) addr, (void *) &ctl->unspec_addr, ctl->af);
+        addrcmp_result = addrcmp(addr, &ctl->unspec_addr, ctl->af);
 
         if (err == 0 && addrcmp_result != 0) {
             name = dns_lookup(ctl, addr);
@@ -472,14 +471,12 @@ static void mtr_curses_hosts(
             }
 
             /* Multi path */
-            for (i = 0; i < MAXPATH; i++) {
+            for (i = 0; i < MAX_PATH; i++) {
                 addrs = net_addrs(at, i);
                 mplss = net_mplss(at, i);
-                if (addrcmp((void *) addrs, (void *) addr, ctl->af) == 0)
+                if (addrcmp(addrs, addr, ctl->af) == 0)
                     continue;
-                if (addrcmp
-                    ((void *) addrs, (void *) &ctl->unspec_addr,
-                     ctl->af) == 0)
+                if (addrcmp(addrs, &ctl->unspec_addr,ctl->af) == 0)
                     break;
 
                 name = dns_lookup(ctl, addrs);
@@ -645,7 +642,7 @@ static void mtr_curses_graph(
         }
 
         if (err == 0
-            && addrcmp((void *) addr, (void *) &ctl->unspec_addr, ctl->af)) {
+            && addrcmp(addr, &ctl->unspec_addr, ctl->af)) {
 
             if (!net_up(at)) {
                 attron(A_BOLD);
@@ -701,7 +698,7 @@ void mtr_curses_redraw(
     pwcenter(buf);
     attroff(A_BOLD);
 
-    mvprintw(1, 0, "%s (%s)", ctl->LocalHostname, net_localaddr());
+    mvprintw(1, 0, "%s (%s) -> %s", ctl->LocalHostname, net_localaddr(), ctl->Hostname);
     t = time(NULL);
     mvprintw(1, maxx - 25, iso_time(&t));
     printw("\n");
diff --git a/ui/display.c b/ui/display.c
index 9a8ac60..7127be5 100644
--- a/ui/display.c
+++ b/ui/display.c
@@ -81,9 +81,11 @@ void display_open(
     case DisplayTXT:
         txt_open();
         break;
+#ifdef HAVE_JANSSON
     case DisplayJSON:
         json_open();
         break;
+#endif
     case DisplayXML:
         xml_open();
         break;
@@ -127,9 +129,11 @@ void display_close(
     case DisplayTXT:
         txt_close(ctl);
         break;
+#ifdef HAVE_JANSSON
     case DisplayJSON:
         json_close(ctl);
         break;
+#endif
     case DisplayXML:
         xml_close(ctl);
         break;
@@ -225,10 +229,11 @@ void display_rawping(
 void display_rawhost(
     struct mtr_ctl *ctl,
     int host,
-    ip_t * ip_addr)
+    ip_t * ip_addr,
+    struct mplslen *mpls)
 {
     if (ctl->DisplayMode == DisplayRaw)
-        raw_rawhost(ctl, host, ip_addr);
+        raw_rawhost(ctl, host, ip_addr, mpls);
 }
 
 
diff --git a/ui/display.h b/ui/display.h
index c577d3f..3eaa291 100644
--- a/ui/display.h
+++ b/ui/display.h
@@ -41,7 +41,9 @@ enum {
     DisplayXML,
     DisplayCSV,
     DisplayTXT,
-    DisplayJSON
+#ifdef HAVE_JANSSON
+    DisplayJSON,
+#endif
 };
 
 enum {
@@ -74,7 +76,8 @@ extern void display_rawping(
 extern void display_rawhost(
     struct mtr_ctl *ctl,
     int hostnum,
-    ip_t * ip_addr);
+    ip_t *ip_addr,
+    struct mplslen *mpls);
 extern int display_keyaction(
     struct mtr_ctl *ctl);
 extern void display_loop(
diff --git a/ui/dns.c b/ui/dns.c
index 8b323ff..7dc8885 100644
--- a/ui/dns.c
+++ b/ui/dns.c
@@ -41,6 +41,7 @@
 #include "dns.h"
 #include "net.h"
 #include "utils.h"
+#include "packet/sockaddr.h"
 
 struct dns_results {
     ip_t ip;
@@ -105,7 +106,7 @@ static struct dns_results *findip(
     struct dns_results *t;
 
     for (t = results; t; t = t->next) {
-        if (addrcmp((void *) ip, (void *) &t->ip, ctl->af) == 0)
+        if (addrcmp(ip, &t->ip, ctl->af) == 0)
             return t;
     }
 
@@ -117,22 +118,9 @@ static void set_sockaddr_ip(
     struct sockaddr_storage *sa,
     ip_t * ip)
 {
-    struct sockaddr_in *sa_in;
-    struct sockaddr_in6 *sa_in6;
-
     memset(sa, 0, sizeof(struct sockaddr_storage));
-    switch (ctl->af) {
-    case AF_INET:
-        sa_in = (struct sockaddr_in *) sa;
-        sa_in->sin_family = ctl->af;
-        addrcpy((void *) &sa_in->sin_addr, (void *) ip, ctl->af);
-        break;
-    case AF_INET6:
-        sa_in6 = (struct sockaddr_in6 *) sa;
-        sa_in6->sin6_family = ctl->af;
-        addrcpy((void *) &sa_in6->sin6_addr, (void *) ip, ctl->af);
-        break;
-    }
+    sa->ss_family = ctl->af;
+    memcpy(sockaddr_addr_offset(sa), ip, sockaddr_addr_size(sa));
 }
 
 void dns_open(
@@ -162,7 +150,7 @@ void dns_open(
             error(EXIT_FAILURE, errno, "signal");
         }
 
-        /* Close all unneccessary FDs.
+        /* Close all unnecessary FDs.
            for debugging and error reporting, keep std-in/out/err. */
         for (i = 3; i < fromdns[1]; i++) {
             if (i == todns[0])
@@ -276,8 +264,6 @@ char *dns_lookup2(
         /* we've got a result. */
         if (r->name)
             return r->name;
-        else
-            return strlongip(ctl, ip);
     } else {
         r = xmalloc(sizeof(struct dns_results));
         memcpy(&r->ip, ip, sizeof(r->ip));
@@ -289,7 +275,7 @@ char *dns_lookup2(
         if (rv < 0)
             error(0, errno, "couldn't write to resolver process");
     }
-    return strlongip(ctl, ip);
+    return NULL;
 }
 
 
@@ -302,7 +288,7 @@ char *dns_lookup(
     if (!ctl->dns || !ctl->use_dns)
         return NULL;
     t = dns_lookup2(ctl, ip);
-    return t;
+    return t ? t : strlongip(ctl, ip);
 }
 
 /* XXX check if necessary/exported. */
diff --git a/ui/gtk.c b/ui/gtk.c
index a978d35..dd79efc 100644
--- a/ui/gtk.c
+++ b/ui/gtk.c
@@ -272,25 +272,25 @@ static void Toolbar_fill(
     GtkWidget *Label;
     GtkAdjustment *Adjustment;
 
-    Button = gtk_button_new_from_stock(GTK_STOCK_QUIT);
+    Button = gtk_button_new_with_label("Quit");
     gtk_box_pack_end(GTK_BOX(Toolbar), Button, FALSE, FALSE, 0);
-    g_signal_connect(GTK_OBJECT(Button), "clicked",
-                     GTK_SIGNAL_FUNC(Window_destroy), NULL);
+    g_signal_connect(G_OBJECT(Button), "clicked",
+                     G_CALLBACK(Window_destroy), NULL);
 
-    Button = gtk_button_new_from_stock(GTK_STOCK_ABOUT);
+    Button = gtk_button_new_with_label("About");
     gtk_box_pack_end(GTK_BOX(Toolbar), Button, FALSE, FALSE, 0);
-    g_signal_connect(GTK_OBJECT(Button), "clicked",
-                     GTK_SIGNAL_FUNC(About_clicked), NULL);
+    g_signal_connect(G_OBJECT(Button), "clicked",
+                     G_CALLBACK(About_clicked), NULL);
 
     Button = gtk_button_new_with_mnemonic("_Restart");
     gtk_box_pack_end(GTK_BOX(Toolbar), Button, FALSE, FALSE, 0);
-    g_signal_connect(GTK_OBJECT(Button), "clicked",
-                     GTK_SIGNAL_FUNC(Restart_clicked), ctl);
+    g_signal_connect(G_OBJECT(Button), "clicked",
+                     G_CALLBACK(Restart_clicked), ctl);
 
     Pause_Button = gtk_toggle_button_new_with_mnemonic("_Pause");
     gtk_box_pack_end(GTK_BOX(Toolbar), Pause_Button, FALSE, FALSE, 0);
-    g_signal_connect(GTK_OBJECT(Pause_Button), "clicked",
-                     GTK_SIGNAL_FUNC(Pause_clicked), ctl);
+    g_signal_connect(G_OBJECT(Pause_Button), "clicked",
+                     G_CALLBACK(Pause_clicked), ctl);
 
     /* allow root only to set zero delay */
     Adjustment = (GtkAdjustment *) gtk_adjustment_new(ctl->WaitTime,
@@ -301,16 +301,16 @@ static void Toolbar_fill(
     gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(Button), TRUE);
     gtk_box_pack_end(GTK_BOX(Toolbar), Button, FALSE, FALSE, 0);
     ctl->gtk_data = Button;
-    g_signal_connect(GTK_OBJECT(Adjustment), "value_changed",
-                     GTK_SIGNAL_FUNC(WaitTime_changed), ctl);
+    g_signal_connect(G_OBJECT(Adjustment), "value_changed",
+                     G_CALLBACK(WaitTime_changed), ctl);
 
     Label = gtk_label_new_with_mnemonic("_Hostname:");
     gtk_box_pack_start(GTK_BOX(Toolbar), Label, FALSE, FALSE, 0);
 
     Entry = gtk_entry_new();
     gtk_entry_set_text(GTK_ENTRY(Entry), ctl->Hostname);
-    g_signal_connect(GTK_OBJECT(Entry), "activate",
-                     GTK_SIGNAL_FUNC(Host_activate), ctl);
+    g_signal_connect(G_OBJECT(Entry), "activate",
+                     G_CALLBACK(Host_activate), ctl);
     gtk_box_pack_start(GTK_BOX(Toolbar), Entry, TRUE, TRUE, 0);
 
     gtk_label_set_mnemonic_widget(GTK_LABEL(Label), Entry);
@@ -394,7 +394,7 @@ static void TreeViewCreate(
     ReportTreeView =
         gtk_tree_view_new_with_model(GTK_TREE_MODEL(ReportStore));
 
-    g_signal_connect(GTK_OBJECT(ReportTreeView), "button_press_event",
+    g_signal_connect(G_OBJECT(ReportTreeView), "button_press_event",
                      G_CALLBACK(ReportTreeView_clicked), ctl);
 
 #ifdef HAVE_IPINFO
@@ -507,7 +507,7 @@ static void update_tree_row(
     char str[256] = "???", *name = str;
 
     addr = net_addr(row);
-    if (addrcmp((void *) addr, (void *) &ctl->unspec_addr, ctl->af)) {
+    if (addrcmp(addr, &ctl->unspec_addr, ctl->af)) {
         if ((name = dns_lookup(ctl, addr))) {
             if (ctl->show_ips) {
                 snprintf(str, sizeof(str), "%s (%s)", name,
@@ -564,6 +564,15 @@ void gtk_redraw(
     }
 }
 
+// GTK 3 has changed the interface a bit. Here a few defines so that we can
+// work with GTK2 or GTK3 as required. 
+#ifdef HAVE_GTK3
+#define gtk_vbox_new_(orientation,sz) gtk_box_new(orientation, sz)
+#define gtk_hbox_new_(orientation,sz) gtk_box_new(orientation, sz)
+#else
+#define gtk_vbox_new_(orientation,sz) gtk_vbox_new(FALSE, sz)
+#define gtk_hbox_new_(orientation,sz) gtk_hbox_new(FALSE, sz)
+#endif
 
 static void Window_fill(
     struct mtr_ctl *ctl,
@@ -576,9 +585,10 @@ static void Window_fill(
     gtk_window_set_title(GTK_WINDOW(Window), "My traceroute");
     gtk_window_set_default_size(GTK_WINDOW(Window), 650, 400);
     gtk_container_set_border_width(GTK_CONTAINER(Window), 10);
-    VBox = gtk_vbox_new(FALSE, 10);
 
-    Toolbar = gtk_hbox_new(FALSE, 10);
+    VBox    = gtk_vbox_new_(GTK_ORIENTATION_VERTICAL,   10);
+    Toolbar = gtk_hbox_new_(GTK_ORIENTATION_HORIZONTAL, 10);
+
     Toolbar_fill(ctl, Toolbar);
     gtk_box_pack_start(GTK_BOX(VBox), Toolbar, FALSE, FALSE, 0);
 
@@ -619,10 +629,10 @@ void gtk_open(
 
     Window_fill(ctl, main_window);
 
-    g_signal_connect(GTK_OBJECT(main_window), "delete_event",
-                     GTK_SIGNAL_FUNC(Window_destroy), NULL);
-    g_signal_connect(GTK_OBJECT(main_window), "destroy",
-                     GTK_SIGNAL_FUNC(Window_destroy), NULL);
+    g_signal_connect(G_OBJECT(main_window), "delete_event",
+                     G_CALLBACK(Window_destroy), NULL);
+    g_signal_connect(G_OBJECT(main_window), "destroy",
+                     G_CALLBACK(Window_destroy), NULL);
 
     gtk_widget_show_all(main_window);
 }
@@ -801,20 +811,24 @@ static gboolean ReportTreeView_clicked(
     newdestination_item =
         gtk_menu_item_new_with_label("Set as new destination");
 
-    gtk_menu_append(GTK_MENU(popup_menu), copy_item);
-    gtk_menu_append(GTK_MENU(popup_menu), newdestination_item);
+    gtk_menu_shell_append(GTK_MENU_SHELL(popup_menu), copy_item);
+    gtk_menu_shell_append(GTK_MENU_SHELL(popup_menu), newdestination_item);
 
-    g_signal_connect(GTK_OBJECT(copy_item), "activate",
-                     GTK_SIGNAL_FUNC(Copy_activate), path);
+    g_signal_connect(G_OBJECT(copy_item), "activate",
+                     G_CALLBACK(Copy_activate), path);
 
     ctl->gtk_data = path;
-    g_signal_connect(GTK_OBJECT(newdestination_item), "activate",
-                     GTK_SIGNAL_FUNC(NewDestination_activate), ctl);
+    g_signal_connect(G_OBJECT(newdestination_item), "activate",
+                     G_CALLBACK(NewDestination_activate), ctl);
 
     gtk_widget_show(copy_item);
     gtk_widget_show(newdestination_item);
 
+#ifdef HAVE_GTK3
+    gtk_menu_popup_at_pointer(GTK_MENU(popup_menu), NULL);
+#else
     gtk_menu_popup(GTK_MENU(popup_menu), NULL, NULL, NULL, NULL,
                    0, event->time);
+#endif
     return TRUE;
 }
diff --git a/ui/mtr.c b/ui/mtr.c
index a3fef48..b33a136 100644
--- a/ui/mtr.c
+++ b/ui/mtr.c
@@ -299,7 +299,7 @@ static void init_fld_options(
 {
     int i;
 
-    memset(ctl->fld_index, -1, FLD_INDEX_SZ);
+    memset(ctl->fld_index, -1, FLD_INDEX_SZ*sizeof(ctl->fld_index[0]));
 
     for (i = 0; data_fields[i].key != 0; i++) {
         ctl->available_options[i] = data_fields[i].key;
@@ -349,7 +349,9 @@ static void parse_arg(
 #endif
         {"raw", 0, NULL, 'l'},
         {"csv", 0, NULL, 'C'},
+#ifdef HAVE_JANSSON
         {"json", 0, NULL, 'j'},
+#endif
         {"displaymode", 1, NULL, OPT_DISPLAYMODE},
         {"split", 0, NULL, 'p'},        /* BL */
         /* maybe above should change to -d 'x' */
@@ -445,9 +447,11 @@ static void parse_arg(
         case 'C':
             ctl->DisplayMode = DisplayCSV;
             break;
+#ifdef HAVE_JANSSON
         case 'j':
             ctl->DisplayMode = DisplayJSON;
             break;
+#endif
         case 'x':
             ctl->DisplayMode = DisplayXML;
             break;
@@ -644,7 +648,9 @@ static void parse_arg(
 
     if (ctl->DisplayMode == DisplayReport ||
         ctl->DisplayMode == DisplayTXT ||
+#ifdef HAVE_JANSSON
         ctl->DisplayMode == DisplayJSON ||
+#endif
         ctl->DisplayMode == DisplayXML ||
         ctl->DisplayMode == DisplayRaw || ctl->DisplayMode == DisplayCSV)
         ctl->Interactive = 0;
diff --git a/ui/mtr.h b/ui/mtr.h
index ac38016..01536f5 100644
--- a/ui/mtr.h
+++ b/ui/mtr.h
@@ -61,7 +61,7 @@ typedef int time_t;
 
 /* net related definitions */
 #define SAVED_PINGS 200
-#define MAXPATH 8
+#define MAX_PATH 8
 #define MaxHost 256
 #define MinPort 1024
 #define MaxPort 65535
diff --git a/ui/net.c b/ui/net.c
index 1c78466..f684b3e 100644
--- a/ui/net.c
+++ b/ui/net.c
@@ -39,20 +39,16 @@
 #include "display.h"
 #include "dns.h"
 #include "utils.h"
+#include "packet/sockaddr.h"
 
 #define MinSequence 33000
 #define MaxSequence 65536
 
 static int packetsize;          /* packet size used by ping */
 
-static void sockaddrtop(
-    struct sockaddr *saddr,
-    char *strptr,
-    size_t len);
-
 struct nethost {
-    ip_t addr;
-    ip_t addrs[MAXPATH];        /* for multi paths byMin */
+    ip_t addr;                  /* Latest host to respond */
+    ip_t addrs[MAX_PATH];        /* For Multi paths/Path Changes: List of all hosts that have responded */
     int err;
     int xmit;
     int returned;
@@ -72,7 +68,7 @@ struct nethost {
     int saved[SAVED_PINGS];
     int saved_seq_offset;
     struct mplslen mpls;
-    struct mplslen mplss[MAXPATH];
+    struct mplslen mplss[MAX_PATH];
 };
 
 
@@ -88,26 +84,13 @@ static struct nethost host[MaxHost];
 static struct sequence sequence[MaxSequence];
 static struct packet_command_pipe_t packet_command_pipe;
 
-#ifdef ENABLE_IPV6
 static struct sockaddr_storage sourcesockaddr_struct;
 static struct sockaddr_storage remotesockaddr_struct;
-static struct sockaddr_in6 *ssa6 =
-    (struct sockaddr_in6 *) &sourcesockaddr_struct;
-static struct sockaddr_in6 *rsa6 =
-    (struct sockaddr_in6 *) &remotesockaddr_struct;
-#else
-static struct sockaddr_in sourcesockaddr_struct;
-static struct sockaddr_in remotesockaddr_struct;
-#endif
 
 static struct sockaddr *sourcesockaddr =
     (struct sockaddr *) &sourcesockaddr_struct;
 static struct sockaddr *remotesockaddr =
     (struct sockaddr *) &remotesockaddr_struct;
-static struct sockaddr_in *ssa4 =
-    (struct sockaddr_in *) &sourcesockaddr_struct;
-static struct sockaddr_in *rsa4 =
-    (struct sockaddr_in *) &remotesockaddr_struct;
 
 static ip_t *sourceaddress;
 static ip_t *remoteaddress;
@@ -124,6 +107,14 @@ static char localaddr[INET_ADDRSTRLEN];
 static int batch_at = 0;
 static int numhosts = 10;
 
+
+#define host_addr_cmp(index, other, af) \
+    addrcmp((void *) &(host[(index)].addr), (void *) (other), (af))
+
+#define host_addrs_cmp(index, path, other, af) \
+    addrcmp((void *) &(host[(index)].addrs[path]), (void *) (other), (af))
+
+
 /* return the number of microseconds to wait before sending the next
    ping */
 int calc_deltatime(
@@ -184,7 +175,7 @@ static void net_send_query(
     int time_to_live = index + 1;
 
     send_probe_command(ctl, &packet_command_pipe, remoteaddress,
-                       sourceaddress, packetsize, seq, time_to_live);
+                       sourceaddress, packet_size, seq, time_to_live);
 }
 
 
@@ -215,6 +206,7 @@ static int mark_sequence_complete(
 
     Record the round trip time and address of the responding host.
 */
+
 static void net_process_ping(
     struct mtr_ctl *ctl,
     int seq,
@@ -227,99 +219,100 @@ static void net_process_ping(
     int oldavg;                 /* usedByMin */
     int oldjavg;                /* usedByMin */
     int i;                      /* usedByMin */
+    int found = 0;
 #ifdef ENABLE_IPV6
     char addrcopy[sizeof(struct in6_addr)];
 #else
     char addrcopy[sizeof(struct in_addr)];
 #endif
+    struct nethost *nh = NULL;
 
-    addrcpy((void *) &addrcopy, (char *) addr, ctl->af);
+    memcpy(&addrcopy, addr, sockaddr_addr_size(sourcesockaddr));
 
     index = mark_sequence_complete(seq);
     if (index < 0) {
         return;
     }
+    nh = &host[index];
+    nh->err = err;
 
-    host[index].err = err;
 
-    if (addrcmp((void *) &(host[index].addr),
-                (void *) &ctl->unspec_addr, ctl->af) == 0) {
-        /* should be out of if as addr can change */
-        addrcpy((void *) &(host[index].addr), addrcopy, ctl->af);
-        host[index].mpls = *mpls;
-        display_rawhost(ctl, index, (void *) &(host[index].addr));
 
-        /* multi paths */
-        addrcpy((void *) &(host[index].addrs[0]), addrcopy, ctl->af);
-        host[index].mplss[0] = *mpls;
-    } else {
-        for (i = 0; i < MAXPATH;) {
-            if (addrcmp
-                ((void *) &(host[index].addrs[i]), (void *) &addrcopy,
-                 ctl->af) == 0
-                || addrcmp((void *) &(host[index].addrs[i]),
-                           (void *) &ctl->unspec_addr, ctl->af) == 0) {
+    if (addrcmp(&nh->addr, &addrcopy, ctl->af) != 0) {
+        for (i = 0; i < MAX_PATH;) {
+            if (addrcmp(&nh->addrs[i], &nh->addr, ctl->af) == 0) {
+                found = 1; /* This host is already in the list */
                 break;
             }
+            if (addrcmp(&nh->addrs[i], &ctl->unspec_addr, ctl->af) == 0) {
+                break; /* Found first vacant position */
+            }
             i++;
         }
 
-        if (addrcmp((void *) &(host[index].addrs[i]), addrcopy, ctl->af) !=
-            0 && i < MAXPATH) {
-            addrcpy((void *) &(host[index].addrs[i]), addrcopy, ctl->af);
-            host[index].mplss[i] = *mpls;
-            display_rawhost(ctl, index, (void *) &(host[index].addrs[i]));
+        if (found == 0 && i < MAX_PATH) {
+            memcpy(&nh->addrs[i], &nh->addr, sockaddr_addr_size(sourcesockaddr));
+
+            nh->mplss[i] = nh->mpls;
+            display_rawhost(ctl, index, (void *)&(nh->addrs[i]), (void *)&(nh->addrs[i]));
         }
+
+        /* Always save the latest host in nh->addr. This
+         * allows maxTTL to change whenever path changes.
+         */
+        memcpy(&nh->addr, addrcopy, sockaddr_addr_size(sourcesockaddr));
+        nh->mpls = *mpls;
+        display_rawhost(ctl, index, (void *)&(nh->addr), (void *)&(nh->mpls));
     }
 
-    host[index].jitter = totusec - host[index].last;
-    if (host[index].jitter < 0) {
-        host[index].jitter = -host[index].jitter;
+    nh->jitter = totusec - nh->last;
+    if (nh->jitter < 0) {
+        nh->jitter = -nh->jitter;
     }
 
-    host[index].last = totusec;
+    nh->last = totusec;
 
-    if (host[index].returned < 1) {
-        host[index].best = host[index].worst = host[index].gmean = totusec;
-        host[index].avg = host[index].ssd = 0;
+    if (nh->returned < 1) {
+        nh->best = nh->worst = nh->gmean = totusec;
+        nh->avg = nh->ssd = 0;
 
-        host[index].jitter = host[index].jworst = host[index].jinta = 0;
+        nh->jitter = nh->jworst = nh->jinta = 0;
     }
 
-    if (totusec < host[index].best) {
-        host[index].best = totusec;
+    if (totusec < nh->best) {
+        nh->best = totusec;
     }
-    if (totusec > host[index].worst) {
-        host[index].worst = totusec;
+    if (totusec > nh->worst) {
+        nh->worst = totusec;
     }
 
-    if (host[index].jitter > host[index].jworst) {
-        host[index].jworst = host[index].jitter;
+    if (nh->jitter > nh->jworst) {
+        nh->jworst = nh->jitter;
     }
 
-    host[index].returned++;
-    oldavg = host[index].avg;
-    host[index].avg += (totusec - oldavg + .0) / host[index].returned;
-    host[index].ssd +=
-        (totusec - oldavg + .0) * (totusec - host[index].avg);
+    nh->returned++;
+    oldavg = nh->avg;
+    nh->avg += (totusec - oldavg + .0) / nh->returned;
+    nh->ssd +=
+        (totusec - oldavg + .0) * (totusec - nh->avg);
 
-    oldjavg = host[index].javg;
-    host[index].javg +=
-        (host[index].jitter - oldjavg) / host[index].returned;
+    oldjavg = nh->javg;
+    nh->javg +=
+        (nh->jitter - oldjavg) / nh->returned;
     /* below algorithm is from rfc1889, A.8 */
-    host[index].jinta +=
-        host[index].jitter - ((host[index].jinta + 8) >> 4);
+    nh->jinta +=
+        nh->jitter - ((nh->jinta + 8) >> 4);
 
-    if (host[index].returned > 1) {
-        host[index].gmean =
-            pow((double) host[index].gmean,
-                (host[index].returned - 1.0) / host[index].returned)
-            * pow((double) totusec, 1.0 / host[index].returned);
+    if (nh->returned > 1) {
+        nh->gmean =
+            pow((double) nh->gmean,
+                (nh->returned - 1.0) / nh->returned)
+            * pow((double) totusec, 1.0 / nh->returned);
     }
 
-    host[index].sent = 0;
-    host[index].up = 1;
-    host[index].transit = 0;
+    nh->sent = 0;
+    nh->up = 1;
+    nh->transit = 0;
 
     net_save_return(index, sequence[seq].saved_seq, totusec);
     display_rawping(ctl, index, totusec, seq);
@@ -475,8 +468,7 @@ int net_max(
 
     max = 0;
     for (at = 0; at < ctl->maxTTL; at++) {
-        if (addrcmp((void *) &(host[at].addr),
-                    (void *) remoteaddress, ctl->af) == 0) {
+        if (host_addr_cmp(at , remoteaddress, ctl->af) == 0) {
             return at + 1;
         } else if (host[at].err != 0) {
             /*
@@ -485,8 +477,7 @@ int net_max(
                 final hop.
             */
             return at + 1;
-        } else if (addrcmp((void *) &(host[at].addr),
-                           (void *) &ctl->unspec_addr, ctl->af) != 0) {
+        } else if (host_addr_cmp(at, &ctl->unspec_addr, ctl->af) != 0) {
             max = at + 2;
         }
     }
@@ -546,6 +537,7 @@ int net_send_batch(
     struct mtr_ctl *ctl)
 {
     int n_unknown = 0, i;
+    int restart = 0;
 
     /* randomized packet size and/or bit pattern if packetsize<0 and/or 
        bitpattern<0.  abs(packetsize) and/or abs(bitpattern) will be used 
@@ -557,7 +549,7 @@ int net_send_batch(
                have a range for "rand()" that runs to 32768, and the 
                destination range is 10000, you end up with 4 out of 32768 
                0-2768's and only 3 out of 32768 for results 2769 .. 9999. 
-               As our detination range (in the example 10000) is much 
+               As our destination range (in the example 10000) is much 
                smaller (reasonable packet sizes), and our rand() range much 
                larger, this effect is insignificant. Oh! That other formula
                didn't work. */
@@ -575,9 +567,7 @@ int net_send_batch(
     net_send_query(ctl, batch_at, abs(packetsize));
 
     for (i = ctl->fstTTL - 1; i < batch_at; i++) {
-        if (addrcmp
-            ((void *) &(host[i].addr), (void *) &ctl->unspec_addr,
-             ctl->af) == 0)
+        if (host_addr_cmp(i, &ctl->unspec_addr, ctl->af) == 0)
             n_unknown++;
 
         /* The second condition in the next "if" statement was added in mtr-0.56, 
@@ -585,19 +575,24 @@ int net_send_batch(
            hosts. Removed in 0.65. 
            If the line proves necessary, it should at least NOT trigger that line
            when host[i].addr == 0 */
-        if ((addrcmp((void *) &(host[i].addr),
-                     (void *) remoteaddress, ctl->af) == 0))
-            n_unknown = MaxHost;        /* Make sure we drop into "we should restart" */
+        if (host_addr_cmp(i, remoteaddress, ctl->af) == 0) {
+            restart = 1;
+            numhosts = i + 1; /* Saves batch_at - index number of probes in the next round!*/
+            break;
+        }
     }
 
     if (                        /* success in reaching target */
-           (addrcmp((void *) &(host[batch_at].addr),
-                    (void *) remoteaddress, ctl->af) == 0) ||
+           (host_addr_cmp(batch_at, remoteaddress, ctl->af) == 0) ||
            /* fail in consecutive maxUnknown (firewall?) */
            (n_unknown > ctl->maxUnknown) ||
            /* or reach limit  */
            (batch_at >= ctl->maxTTL - 1)) {
+        restart = 1;
         numhosts = batch_at + 1;
+    }
+
+    if(restart) {
         batch_at = ctl->fstTTL - 1;
         return 1;
     }
@@ -644,7 +639,7 @@ static void net_find_interface_address_from_name(
 
     interface = ifaddrs;
     while (interface != NULL) {
-        if (!strcmp(interface->ifa_name, interface_name)) {
+        if (interface->ifa_addr != NULL && !strcmp(interface->ifa_name, interface_name)) {
             found_interface_name = 1;
 
             if (interface->ifa_addr->sa_family == address_family) {
@@ -690,8 +685,6 @@ static void net_find_local_address(
     int udp_socket;
     int addr_length;
     struct sockaddr_storage remote_sockaddr;
-    struct sockaddr_in *remote4;
-    struct sockaddr_in6 *remote6;
 
     udp_socket =
         socket(remotesockaddr->sa_family, SOCK_DGRAM, IPPROTO_UDP);
@@ -703,24 +696,12 @@ static void net_find_local_address(
        We need to set the port to a non-zero value for the connect
        to succeed.
      */
-    if (remotesockaddr->sa_family == AF_INET6) {
-#ifdef ENABLE_IPV6
-        addr_length = sizeof(struct sockaddr_in6);
-
-        memcpy(&remote_sockaddr, rsa6, addr_length);
-        remote6 = (struct sockaddr_in6 *) &remote_sockaddr;
-        remote6->sin6_port = htons(1);
-#endif
-    } else {
-        addr_length = sizeof(struct sockaddr_in);
-
-        memcpy(&remote_sockaddr, rsa4, addr_length);
-        remote4 = (struct sockaddr_in *) &remote_sockaddr;
-        remote4->sin_port = htons(1);
-    }
+    addr_length = sockaddr_size(&remotesockaddr_struct);
+    memcpy(&remote_sockaddr, &remotesockaddr_struct, addr_length);
+    *sockaddr_port_offset(&remote_sockaddr) = htons(1);
 
     if (connect
-        (udp_socket, (struct sockaddr *) &remote_sockaddr, addr_length)) {
+        (udp_socket, (struct sockaddr *) &remote_sockaddr, sockaddr_size(&remote_sockaddr))) {
 #ifdef __linux__
         /* Linux doesn't require source address, so we can support
          * a case when mtr is run against unreachable host (that can become
@@ -739,7 +720,7 @@ static void net_find_local_address(
         error(EXIT_FAILURE, errno, "local address determination failed");
     }
 
-    sockaddrtop(sourcesockaddr, localaddr, sizeof(localaddr));
+    inet_ntop(sourcesockaddr->sa_family, sockaddr_addr_offset(sourcesockaddr), localaddr, sizeof(localaddr));
 
     close(udp_socket);
 }
@@ -759,32 +740,18 @@ int net_open(
 
     net_reset(ctl);
 
-    remotesockaddr->sa_family = hostent->h_addrtype;
+    remotesockaddr->sa_family = sourcesockaddr->sa_family = hostent->h_addrtype;
+    memcpy(sockaddr_addr_offset(remotesockaddr), hostent->h_addr, sockaddr_addr_size(remotesockaddr));
 
-    switch (hostent->h_addrtype) {
-    case AF_INET:
-        addrcpy((void *) &(rsa4->sin_addr), hostent->h_addr, AF_INET);
-        sourceaddress = (ip_t *) & (ssa4->sin_addr);
-        remoteaddress = (ip_t *) & (rsa4->sin_addr);
-        break;
-#ifdef ENABLE_IPV6
-    case AF_INET6:
-        addrcpy((void *) &(rsa6->sin6_addr), hostent->h_addr, AF_INET6);
-        sourceaddress = (ip_t *) & (ssa6->sin6_addr);
-        remoteaddress = (ip_t *) & (rsa6->sin6_addr);
-        break;
-#endif
-    default:
-        error(EXIT_FAILURE, 0, "net_open bad address type");
-    }
+    sourceaddress = sockaddr_addr_offset(sourcesockaddr);
+    remoteaddress = sockaddr_addr_offset(remotesockaddr);
 
     if (ctl->InterfaceAddress) {
         net_validate_interface_address(ctl->af, ctl->InterfaceAddress);
     } else if (ctl->InterfaceName) {
         net_find_interface_address_from_name(
             &sourcesockaddr_struct, ctl->af, ctl->InterfaceName);
-
-        sockaddrtop(sourcesockaddr, localaddr, sizeof(localaddr));
+        inet_ntop(sourcesockaddr->sa_family, sockaddr_addr_offset(sourcesockaddr), localaddr, sizeof(localaddr));
     } else {
         net_find_local_address();
     }
@@ -804,21 +771,8 @@ void net_reopen(
     }
 
     remotesockaddr->sa_family = addr->h_addrtype;
-    addrcpy((void *) remoteaddress, addr->h_addr, addr->h_addrtype);
-
-    switch (addr->h_addrtype) {
-    case AF_INET:
-        addrcpy((void *) &(rsa4->sin_addr), addr->h_addr, AF_INET);
-        break;
-#ifdef ENABLE_IPV6
-    case AF_INET6:
-        addrcpy((void *) &(rsa6->sin6_addr), addr->h_addr, AF_INET6);
-        break;
-#endif
-    default:
-        error(EXIT_FAILURE, 0, "net_reopen bad address type");
-    }
-
+    memcpy(remoteaddress, addr->h_addr, sockaddr_addr_size(remotesockaddr));
+    memcpy(sockaddr_addr_offset(remotesockaddr), addr->h_addr, sockaddr_addr_size(remotesockaddr));
     net_reset(ctl);
     net_send_batch(ctl);
 }
@@ -907,41 +861,10 @@ void net_save_return(
     host[at].saved[idx] = ms;
 }
 
-/* Similar to inet_ntop but uses a sockaddr as it's argument. */
-static void sockaddrtop(
-    struct sockaddr *saddr,
-    char *strptr,
-    size_t len)
-{
-    struct sockaddr_in *sa4;
-#ifdef ENABLE_IPV6
-    struct sockaddr_in6 *sa6;
-#endif
-
-    switch (saddr->sa_family) {
-    case AF_INET:
-        sa4 = (struct sockaddr_in *) saddr;
-        xstrncpy(strptr, inet_ntoa(sa4->sin_addr), len - 1);
-        strptr[len - 1] = '\0';
-        return;
-#ifdef ENABLE_IPV6
-    case AF_INET6:
-        sa6 = (struct sockaddr_in6 *) saddr;
-        inet_ntop(sa6->sin6_family, &(sa6->sin6_addr), strptr, len);
-        return;
-#endif
-    default:
-        error(0, 0, "sockaddrtop unknown address type");
-        strptr[0] = '\0';
-        return;
-    }
-}
-
-
 /* Address comparison. */
 int addrcmp(
-    char *a,
-    char *b,
+    void *a,
+    void *b,
     int family)
 {
     int rc = -1;
@@ -960,25 +883,6 @@ int addrcmp(
     return rc;
 }
 
-/* Address copy. */
-void addrcpy(
-    char *a,
-    char *b,
-    int family)
-{
-
-    switch (family) {
-    case AF_INET:
-        memcpy(a, b, sizeof(struct in_addr));
-        break;
-#ifdef ENABLE_IPV6
-    case AF_INET6:
-        memcpy(a, b, sizeof(struct in6_addr));
-        break;
-#endif
-    }
-}
-
 /* for GTK frontend */
 void net_harvest_fds(
     struct mtr_ctl *ctl)
diff --git a/ui/net.h b/ui/net.h
index 0fb4700..8a0d775 100644
--- a/ui/net.h
+++ b/ui/net.h
@@ -117,12 +117,8 @@ extern void net_save_return(
     int ms);
 
 extern int addrcmp(
-    char *a,
-    char *b,
-    int af);
-extern void addrcpy(
-    char *a,
-    char *b,
+    void *a,
+    void *b,
     int af);
 
 extern void net_add_fds(
diff --git a/ui/raw.c b/ui/raw.c
index 429a831..0735131 100644
--- a/ui/raw.c
+++ b/ui/raw.c
@@ -64,12 +64,19 @@ void raw_rawping(
     fflush(stdout);
 }
 
-
 void raw_rawhost(
     struct mtr_ctl *ctl,
     int host,
-    ip_t * ip_addr)
+    ip_t *ip_addr,
+    struct mplslen *mpls)
 {
     printf("h %d %s\n", host, strlongip(ctl, ip_addr));
+    if (ctl->enablempls) {
+        int k;
+        for (k = 0; k < mpls->labels; k++)
+            printf("m %d %lu %u %u %u\n",
+                   host, mpls->label[k], mpls->tc[k], mpls->s[k], mpls->ttl[k]);
+    }
+
     fflush(stdout);
 }
diff --git a/ui/raw.h b/ui/raw.h
index bd1920c..3c9a075 100644
--- a/ui/raw.h
+++ b/ui/raw.h
@@ -30,4 +30,5 @@ extern void raw_rawping(
 extern void raw_rawhost(
     struct mtr_ctl *ctl,
     int host,
-    ip_t * addr);
+    ip_t *addr,
+    struct mplslen *mpls);
diff --git a/ui/report.c b/ui/report.c
index 97a3fa4..b79f593 100644
--- a/ui/report.c
+++ b/ui/report.c
@@ -26,6 +26,14 @@
 #include <string.h>
 #include <strings.h>
 #include <time.h>
+#ifdef HAVE_JANSSON
+#include <jansson.h>
+#endif
+#ifdef HAVE_ERROR_H
+#include <error.h>
+#else
+#include "portability/error.h"
+#endif
 
 #include "mtr.h"
 #include "report.h"
@@ -176,15 +184,25 @@ void report_close(
 
         /* This feature shows 'loadbalances' on routes */
 
-        /* z is starting at 1 because addrs[0] is the same that addr */
-        for (z = 1; z < MAXPATH; z++) {
+        /* Print list of all hosts that have responded from ttl = at + 1 away */
+        for (z = 0; z < MAX_PATH; z++) {
             int found = 0;
             addr2 = net_addrs(at, z);
             mplss = net_mplss(at, z);
             if ((addrcmp
                  ((void *) &ctl->unspec_addr, (void *) addr2,
-                  ctl->af)) == 0)
+                  ctl->af)) == 0) {
                 break;
+            } else if ((addrcmp
+                        ((void *) addr, (void *) addr2,
+                          ctl->af)) == 0) {
+                continue; /* Latest Host is already printed */
+            } else {
+                snprint_addr(ctl, name, sizeof(name), addr2);
+                snprintf(fmt, sizeof(fmt), "        %%-%zus", len_hosts);
+                snprintf(buf, sizeof(buf), fmt,  name);
+                printf("%s\n", buf);
+            }
             for (w = 0; w < z; w++)
                 /* Ok... checking if there are ips repeated on same hop */
                 if ((addrcmp
@@ -269,111 +287,111 @@ void txt_close(
     report_close(ctl);
 }
 
-
+#ifdef HAVE_JANSSON
 void json_open(
     void)
 {
 }
 
-
-void json_close(
-    struct mtr_ctl *ctl)
+void json_close(struct mtr_ctl *ctl)
 {
-    int i, j, at, first, max;
+    int i, j, at, max;
+    int ret;
+    char buf[128];
+    json_t *jreport, *jmtr, *jhubs, *jh;
     ip_t *addr;
     char name[MAX_FORMAT_STR];
 
-    printf("{\n");
-    printf("  \"report\": {\n");
-    printf("    \"mtr\": {\n");
-    printf("      \"src\": \"%s\",\n", ctl->LocalHostname);
-    printf("      \"dst\": \"%s\",\n", ctl->Hostname);
-    printf("      \"tos\": \"0x%X\",\n", ctl->tos);
+    jmtr = json_pack("{ss ss si si}",
+                     "src", ctl->LocalHostname,
+                     "dst", ctl->Hostname,
+                     "tos", ctl->tos,
+                     "tests", ctl->MaxPing);
+    if (!jmtr)
+        goto on_error;
+
     if (ctl->cpacketsize >= 0) {
-        printf("      \"psize\": \"%d\",\n", ctl->cpacketsize);
+        snprintf(buf, sizeof(buf), "%d", ctl->cpacketsize);
     } else {
-        printf("      \"psize\": \"rand(%d-%d)\",\n", MINPACKET,
-               -ctl->cpacketsize);
+        snprintf(buf, sizeof(buf), "rand(%d-%d)", MINPACKET, -ctl->cpacketsize);
     }
+    ret = json_object_set_new(jmtr, "psize", json_string(buf));
+    if (ret == -1)
+        goto on_error;
+
     if (ctl->bitpattern >= 0) {
-        printf("      \"bitpattern\": \"0x%02X\",\n",
-               (unsigned char) (ctl->bitpattern));
+        snprintf(buf, sizeof(buf), "0x%02X", (unsigned char)(ctl->bitpattern));
     } else {
-        printf("      \"bitpattern\": \"rand(0x00-FF)\",\n");
+        snprintf(buf, sizeof(buf), "rand(0x00-FF)");
     }
-    printf("      \"tests\": \"%d\"\n", ctl->MaxPing);
-    printf("    },\n");
 
-    printf("    \"hubs\": [");
+    ret = json_object_set_new(jmtr, "bitpattern", json_string(buf));
+    if (ret == -1)
+        goto on_error;
+
+    jhubs = json_array();
+    if (!jhubs)
+        goto on_error;
 
     max = net_max(ctl);
-    at = first = net_min(ctl);
+    at = net_min(ctl);
     for (; at < max; at++) {
         addr = net_addr(at);
         snprint_addr(ctl, name, sizeof(name), addr);
 
-        if (at == first) {
-            printf("{\n");
-        } else {
-            printf("    {\n");
-        }
-        printf("      \"count\": \"%d\",\n", at + 1);
-        printf("      \"host\": \"%s\",\n", name);
+        jh = json_pack("{si ss}", "count", at + 1, "host", name);
+        if (!jh)
+            goto on_error;
+
 #ifdef HAVE_IPINFO
         if(!ctl->ipinfo_no) {
-          char* fmtinfo = fmt_ipinfo(ctl, addr);
-          if (fmtinfo != NULL) fmtinfo = trim(fmtinfo, '\0');
-          printf("      \"ASN\": \"%s\",\n", fmtinfo);
+            char* fmtinfo = fmt_ipinfo(ctl, addr);
+            if (fmtinfo != NULL)
+                fmtinfo = trim(fmtinfo, '\0');
+
+            ret = json_object_set_new(jh, "ASN", json_string(fmtinfo));
+            if (ret == -1)
+                goto on_error;
         }
 #endif
-        for (i = 0; i < MAXFLD; i++) {
-            const char *format;
 
+        for (i = 0; i < MAXFLD; i++) {
             j = ctl->fld_index[ctl->fld_active[i]];
 
-            /* Commas */
-            if (i + 1 == MAXFLD) {
-                printf("\n");
-            } else if (j > 0 && i != 0) {
-                printf(",\n");
-            }
-
             if (j <= 0)
-                continue;       /* Field nr 0, " " shouldn't be printed in this method. */
+                continue; /* Field nr 0, " " shouldn't be printed in this method. */
 
-            /* Format value */
-            format = data_fields[j].format;
-            if (strchr(format, 'f')) {
-                format = "%.2f";
-            } else {
-                format = "%d";
-            }
-
-            /* Format json line */
-            snprintf(name, sizeof(name), "%s%s", "      \"%s\": ", format);
-
-            /* Output json line */
             if (strchr(data_fields[j].format, 'f')) {
-                /* 1000.0 is a temporay hack for stats usec to ms, impacted net_loss. */
-                printf(name,
-                       data_fields[j].title,
-                       data_fields[j].net_xxx(at) / 1000.0);
+                ret = json_object_set_new(
+                    jh, data_fields[j].title,
+                    json_real(data_fields[j].net_xxx(at) / 1000.0));
             } else {
-                printf(name,
-                       data_fields[j].title, data_fields[j].net_xxx(at));
+                ret = json_object_set_new(
+                    jh, data_fields[j].title,
+                    json_integer(data_fields[j].net_xxx(at)));
             }
+            if (ret == -1)
+                goto on_error;
         }
-        if (at + 1 == max) {
-            printf("    }");
-        } else {
-            printf("    },\n");
-        }
+
+        ret = json_array_append_new(jhubs, jh);
+        if (ret == -1)
+            goto on_error;
     }
-    printf("]\n");
-    printf("  }\n");
-    printf("}\n");
-}
 
+    jreport = json_pack("{s{so so}}", "report", "mtr", jmtr, "hubs", jhubs);
+
+    ret = json_dumpf(jreport, stdout, JSON_INDENT(4) | JSON_REAL_PRECISION(5));
+    if (ret == -1)
+        goto on_error;
+
+    printf("\n"); // bash promt should be on new line
+    json_decref(jreport);
+    return;
+on_error:
+    error(EXIT_FAILURE, 0, "json_close failed");
+}
+#endif
 
 
 void xml_open(
diff --git a/ui/split.c b/ui/split.c
index c0f46be..d300404 100644
--- a/ui/split.c
+++ b/ui/split.c
@@ -92,7 +92,7 @@ void split_redraw(
      */
     for (at = 0; at < max; at++) {
         addr = net_addr(at);
-        if (addrcmp((void *) addr, (void *) &ctl->unspec_addr, ctl->af)) {
+        if (addrcmp(addr, &ctl->unspec_addr, ctl->af)) {
             char str[256], *name;
             if (!(name = dns_lookup(ctl, addr)))
                 name = strlongip(ctl, addr);
